﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace N5
{
    class Program
    {

        //koristimo strukturu podataka da zapamtimo i vrednost ranca i predmete koji su u njemu
        struct Ranac
        {
            public int vrednost;
            public String predmeti;

            public Ranac(int vrednost, String predmeti)
            {
                this.vrednost = vrednost;
                this.predmeti = predmeti;
            }
        }

        static Ranac ranacRekurzivno(int[] v, int[] x, int c)
        {
            //iako deluje da se nismo pobrinuli za sve moguce izlaze, npr. kada kapacitet nije 0, a ne moze da se "ugura" nijedan predmet
            //to je uradjeno implicitno kasnije, jer se nece ulaziti dalje u rekurziju ako 
            if (c == 0)
                return new Ranac(0, "");

            Ranac najbolje=new Ranac(0,"");
            for (int i = 0; i < v.Length; i++)
            {
                if (v[i] <= c)
                {
                    //gledamo sta bi dobili ako bi ubacili predmet i, i resavamo za preostali kapacitet rekurzivno
                    Ranac potproblem = ranacRekurzivno(v, x, c - v[i]);
                    //novo resenje se pravi od resenja potproblema tako sto se poveca za vrednost dodatog predmeta
                    Ranac novo = new Ranac(potproblem.vrednost + x[i], potproblem.predmeti + " " + i);
                    //ako je ubacivanje i-tog predmeta na taj nacin proizvelo bolji rezultat od trenutno najboljeg - pamtimo
                    if (novo.vrednost > najbolje.vrednost)
                    {
                        najbolje = novo;

                    }
                }
            }
            return najbolje;
        }

        static Ranac ranacDinamicki(int[] v, int[] x, int c){

            //niz a je spisak optimalnih resenja za svaki od kapaciteta +1 za kapacitet nula
            int[] a=new int[c+1]; //inicijalno su svuda 0, to je ok
            int[] p = new int[c+1]; //niz odabranih predmeta za svaki kapacitet
            //resavamo redom za kapacitete od 0 do c, i pamtimo u svakom koraku samo poslednji dodati predmet
            int kapacitet;
            for(kapacitet=0; kapacitet<=c; kapacitet++){
                for (int i = 0; i < v.Length; i++)
                {
                    //ako ubacivanje i-tog predmeta doprinosi povecanju vrednosti ranca, ubacujemo ga
                    if (v[i]<=kapacitet && a[kapacitet - v[i]] + x[i] > a[kapacitet])
                    {
                        a[kapacitet] = a[kapacitet - v[i]] + x[i];
                        p[kapacitet] = i;
                    }
                }
            }

            //sada imamo za svaki kapacitet predmet koji je sigurno u njemu, vracamo se unazad i svodimo na potprobleme sad
            kapacitet = c;
            String predmeti = "";
            while (kapacitet > 0)
            {
                predmeti += (" "+p[kapacitet]);
                kapacitet -= v[p[kapacitet]]; //oduzimamo zapreminu koja je odgovarala tom predmetu
            }
            return new Ranac(a[c], predmeti);
        }

        static void Main(string[] args)
        {
            int[] v = new int[] {1,2,8,14,6,13,7};
            int[] x = new int[] {1,3,15,15,7,15,8};
            int c = 10;
            //u ovom nizu ce se pamtiti koliko je puta svaki od predmeta odabran (inicijalno su sve nule)
            int[] p = new int[v.Length];
            Ranac resenje = ranacRekurzivno(v, x, c);
            Console.WriteLine("Rekurzivno resenje: "+resenje.vrednost + " " + resenje.predmeti);
            resenje = ranacDinamicki(v, x, c);
            Console.WriteLine("Dinamicko resenje: " + resenje.vrednost + " " + resenje.predmeti);
        }
    }
}
